// Brief.java
// fr das Lehrbuch "Programmieren mit Java"
// Version 1.0
// Author: Ilse Schmiedecke / Prof. Solymosi, (c): APSIS GmbH
// Datum: 14. Oktober 1998

import java.io.*;

/**  Klasse Brief (Hauptprogramm)
*    Liest eine Datei ein, die einen Brief enthlt.
*    Der Brief muss mit "Liebe Oma!" anfangen und mit "Viele Gruesse XXXXX" enden.
*    In dieser Datei mu "Petruschka" durch XXXXX ersetzt werden (und evtl. "ihre" durch "seine")
*    Die Klasse Oma vertauscht Empfnger und Absender des Briefes.
*    Der Name der Datei kann als Parameter beim Interpreteraufruf mitgegeben werden.
*    Fehlt der Parameter, fordert das Programm die Eingabe des Dateinamens ber die Tastatur an.
*/


class Brief {

   static InputStream in;
   static OutputStream out = System.out;
   static int ch=0;
      
   private static final String Ueberschrift [] =
      {"Petruschka", "schreibt", "an", "ihre", "Oma"};      
   
   private static final String CR = "\n\r";

   public static void main (String [] args) {
     try {
      schreibeUeberschrift();
      if (args.length == 0)
         { String name = liesDateiname();
           in = new FileInputStream(name);
         }
      else in = new FileInputStream(args[0]);    
      schreibeAnrede();
      ch = ueberliesAnrede();
      if (ch == -1) return;
      echoBisGruesse();
      schreibeGruss();
     }
     catch (IOException e) {System.out.println("Schade, Petruschka! Diese Datei finde ich nicht!");return;}
   }


    private static String liesDateiname() throws IOException {
      System.out.println("Petruschka, bitte gib den Dateinamen ein!"+CR);
      StringBuffer Puffer = new StringBuffer();
      String name;
      ch = System.in.read();
      while (!istEOL(ch)) {Puffer.append((char)ch); ch = System.in.read(); }
      return Puffer.toString();
    }

    private static boolean istEOL(int zeichen) {
      return ((char)zeichen=='\n' || (char)zeichen=='\r');
    }

    private static boolean istEOF(int zeichen) {
      return (zeichen==-1);
    }

    private static void schreibeUeberschrift() {
      if (Ueberschrift[3]=="ihre")
           System.out.println("Oma schreibt an ihre " + Ueberschrift[0] + CR + CR);
      else System.out.println("Oma schreibt an ihren " + Ueberschrift[0] + CR + CR);
    }
    
    private static void schreibeAnrede() {
      if (Ueberschrift[3]=="ihre")            
         System.out.println(CR + "Liebe " + Ueberschrift[0] + "!" );
      else System.out.println(CR + "Lieber " + Ueberschrift[0] + "!" );
    }
      
    private static int ueberliesAnrede() throws IOException {
      ch = in.read();
      while (!((char)ch == '!'))
         {if (istEOL(ch) || istEOF(ch)) {System.out.println("Fehler, Petruschka: kein ! in Anrede."); return ch;}
          ch = in.read();
         }
      return ch;
    }

    private static void echoBisGruesse() throws IOException {
      StringBuffer Puffer = new StringBuffer();
      while (! Puffer.toString().endsWith("Viele Gruesse") && !istEOF(ch))
         { ch = in.read(); Puffer.append((char)ch);out.write(ch);}
      }

    private static void schreibeGruss () {
      System.out.println(CR + "            Deine Oma");
    }

}
