// Menuegenerator.java
// fr das Lehrbuch "Programmieren mit Java"
// Version 2.1
// Author: Ilse Schmiedecke / Prof. Solymosi, (c): APSIS GmbH
// Datum: 14. Oktober 1999

import java.io.*;

/** Klasse Menuegenerator 
*	erzeugt im Dialog am Bildschirm eine Menueklasse mit aufgeschobenen Rueckrufmethoden 
*	unter Benutzung der Textdatei Menueschablone.txt im selben Verzeichnis
* Benutzung: Kopieren der Dateien Menuegenerator.class und Menueschablone.txt ins Arbeitsverzeichnis,
* Aufruf mit "java Menuegenerator"
* Die (parameterlosen!) Rckrufprozeduren knnen als Namen (ohne Klammern) oder Aufrufe eigegeben werden. 
*/ 

public class Menuegenerator { 
	private static final String ver = "2.1 vom 14. Oktober 1999";
	private static final String tab = "	";
	private static final String zw = "\r\n";	
	static private int menuelaenge = 0; // Anzahl Menuepunkte ohne "Ende"
	static private String eingabe = "";
	static private String[] eing;
	static private InputStream tastatur = System.in;
	static private FileOutputStream zieldatei;
	static private PrintWriter ausgabe;

	public static void main (String[] args) {		
		try {
			dateiUndKlassennamenSetzen();
			konstruktorenDefinieren();
			startDefinieren();
			menuepunkteAufbauen();
			eing = new String[menuelaenge];
			block1();
			rueckrufeVerbinden();
			rueckrufeDefinieren();
			block3();
			ausgabe.flush();
		}
		catch (IOException e) {
			System.out.println("Dateifehler: " + e);
		}
	}
		
	private static void dateiUndKlassennamenSetzen() throws IOException {
		eingabe = tastaturEingabe("Wie soll die Menueklasse heissen?");
		zieldatei = new FileOutputStream(eingabe + ".java");	
		ausgabe = new PrintWriter(zieldatei, true);
		einfuegen("// Aufgeschobene Menueklasse " + eingabe + zw);
		einfuegen("// erzeugt vom Menuegenerator, Version " + ver + zw + zw);
		einfuegen("import lehrbuch.Anim;" + zw + zw);
		einfuegen("abstract public class " + eingabe + " extends java.applet.Applet {");
		einfuegen(zw);
	}
	
	private static void konstruktorenDefinieren() throws IOException {
		einfuegen(tab + "public " + eingabe + " () {}");
		einfuegen(zw + tab + "public " + eingabe + " (String menuename) {");
		einfuegen(zw + tab + tab + "name = menuename;");
		einfuegen(zw + tab + "}");
		einfuegen(zw);
	}

	private static void startDefinieren() throws IOException {
		einfuegen(tab + "public void start() { // zum Ueberschreiben, ruft menue auf" + zw);
		einfuegen(tab + tab + "menue();" + zw);
		einfuegen(tab + "}" + zw);
	}
					
	private static void menuepunkteAufbauen () throws IOException {
menuelaenge = 0;
		eingabe = tastaturEingabe("Bitte Menuetitel eingeben:");
		einfuegen(tab);
		einfuegen("private String name = \"" + eingabe + "\"; ");
		einfuegen(zw + tab);
		einfuegen("private String[] punkte = {" + zw);
		eingabe = tastaturEingabe("Bitte ersten Menuepunkt eingeben:");
		while (!eingabe.equals("Ende")) {
			menuelaenge++; 
			einfuegen(tab + tab + "\"" + eingabe + "\", " + zw);
			eingabe = tastaturEingabe("Bitte naechsten Menuepunkt eingeben, oder 'Ende':");
		}
		einfuegen(tab + tab + "\"Ende\"" + zw + tab + "};" + zw);
	}
	
	private static void rueckrufeVerbinden() throws IOException {
		for (int i=0; i<menuelaenge; i++) {
			einfuegen(tab + tab + tab + "  ");
			eing[i] = tastaturEingabe("Bitte Methodenaufruf fuer "+(i+1)+". Punkt eingeben:");
			if (!eing[i].endsWith(")") && !eing[i].endsWith(");")) 
				eing[i] = eing[i] + "()"; //  ggf. Parameterklammern ergaenzen
				einfuegen("case " + i + ": " + eing[i] + "; break;" + zw);
		}
		einfuegen(tab + tab + tab + "  ");
		einfuegen("case " + menuelaenge + ": break; // Ende");
		einfuegen(zw);
		einfuegen(tab + tab + "}" + zw);
		einfuegen(tab + "}" + zw);
	}
	
	private static void rueckrufeDefinieren() throws IOException {
		for (int i=0; i<menuelaenge; i++) {
			einfuegen(zw + tab);
			einfuegen("abstract protected void " + eing[i] + "; // zum Ueberschreiben");
			}
			einfuegen(zw);
	}
	
	
	private static void block1() throws IOException {
		final String block[] = {tab + "public void menue() {",
			tab + tab + "Anim.zeigenIndexMenue(name, punkte);",
			tab + tab + "boolean ende = false;",
			tab + tab + "while (!ende) {",
			tab + tab + tab + "int ausw = Anim.holenMenueAuswahlIndex();",
			tab + tab + tab + "ende = ausw == punkte.length-1;",
			tab + tab + tab + "aufrufen(ausw);",
			tab + tab + "}",
			tab + tab + "Anim.loeschenMenue();",
			tab + "}",
			tab + "public void menueEntfernen() {",
			tab + tab + "Anim.loeschenMenue();",
			tab + "}",
			tab + "private void aufrufen (int auswahl) {",
			tab + tab + "switch (auswahl) {",
		};

		for (int i = 0; i < block.length; i++)
			ausgabe.println(block[i]);
	}
	private static void block3() throws IOException {
		einfuegen("}");
	}

	private static void einfuegen(String s) throws IOException {
		ausgabe.print(s);
	}

	private static String tastaturEingabe(String dialogtext) throws IOException {
		System.out.println(dialogtext);
		StringBuffer puffer = new StringBuffer(); // von der Tastatur zeichenweise lesen
		int ch = tastatur.read();
		while ((char)ch != '\n' && (char)ch != '\r' ) { // EOL?
			puffer.append((char)ch);


			ch = tastatur.read();
		}
		ch = tastatur.read();
		return puffer.toString();
	}

}

